Index: applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/gui/LocationSelector.java
===================================================================
--- applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/gui/LocationSelector.java	(revision 15558)
+++ applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/gui/LocationSelector.java	(revision 15582)
@@ -1,6 +1,6 @@
 package org.openstreetmap.josm.plugins.czechaddress.gui;
 
-import org.openstreetmap.josm.plugins.czechaddress.*;
 import java.awt.Component;
+import java.awt.Font;
 import java.util.ArrayList;
 
@@ -55,6 +55,6 @@
 
         oblastComboBox.setRenderer(new AddressElementRenderer());
-        obecComboBox.setRenderer(new AddressElementRenderer());
-        castObceComboBox.setRenderer(new AddressElementRenderer());
+        vitociComboBox.setRenderer(new AddressElementRenderer());
+        suburbComboBox.setRenderer(new SuburbRenderer());
 
         oblastComboBox.setModel(new DefaultComboBoxModel(
@@ -146,8 +146,8 @@
                         if (obec.getName().toUpperCase().equals(bestFit.get("name").toUpperCase())) {
                             oblastComboBox.setSelectedItem(oblast);
-                            obecComboBox.setSelectedItem(obec);
+                            vitociComboBox.setSelectedItem(obec);
                             for (Suburb castObce : obec.getSuburbs()) {
                                 if (castObce.getName().toUpperCase().equals(bestFit.get("name").toUpperCase())) {
-                                    castObceComboBox.setSelectedItem(castObce);
+                                    suburbComboBox.setSelectedItem(castObce);
                                     break;
                                 }
@@ -159,6 +159,6 @@
                             if (castObce.getName().toUpperCase().equals(bestFit.get("name").toUpperCase())) {
                                 oblastComboBox.setSelectedItem(oblast);
-                                obecComboBox.setSelectedItem(obec);
-                                castObceComboBox.setSelectedItem(castObce);
+                                vitociComboBox.setSelectedItem(obec);
+                                suburbComboBox.setSelectedItem(castObce);
                                 break;
                             }
@@ -176,19 +176,20 @@
      */
     @SuppressWarnings("unchecked")
-    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
+    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
     private void initComponents() {
+
         mainPanel = new javax.swing.JPanel();
         oblastComboBox = new javax.swing.JComboBox();
-        castObceComboBox = new javax.swing.JComboBox();
-        obecComboBox = new javax.swing.JComboBox();
+        suburbComboBox = new javax.swing.JComboBox();
+        vitociComboBox = new javax.swing.JComboBox();
         obecLabel = new javax.swing.JLabel();
         castObceLabel = new javax.swing.JLabel();
         oblastLabel = new javax.swing.JLabel();
 
+        setTitle("Výběr umístění");
+        setModal(true);
+        setName("locationSelector"); // NOI18N
         getContentPane().setLayout(new java.awt.GridLayout(1, 0));
 
-        setTitle("V\u00fdb\u011br um\u00edst\u011bn\u00ed");
-        setModal(true);
-        setName("locationSelector");
         oblastComboBox.addItemListener(new java.awt.event.ItemListener() {
             public void itemStateChanged(java.awt.event.ItemEvent evt) {
@@ -197,13 +198,13 @@
         });
 
-        castObceComboBox.addItemListener(new java.awt.event.ItemListener() {
+        suburbComboBox.addItemListener(new java.awt.event.ItemListener() {
             public void itemStateChanged(java.awt.event.ItemEvent evt) {
-                castObceComboBoxItemStateChanged(evt);
+                suburbComboBoxItemStateChanged(evt);
             }
         });
 
-        obecComboBox.addItemListener(new java.awt.event.ItemListener() {
+        vitociComboBox.addItemListener(new java.awt.event.ItemListener() {
             public void itemStateChanged(java.awt.event.ItemEvent evt) {
-                obecComboBoxItemStateChanged(evt);
+                vitociComboBoxItemStateChanged(evt);
             }
         });
@@ -211,7 +212,7 @@
         obecLabel.setText("Obec:");
 
-        castObceLabel.setText("\u010c\u00e1st obce:");
-
-        oblastLabel.setText("Oblast:");
+        castObceLabel.setText("Část obce:");
+
+        oblastLabel.setText("ORP:");
 
         javax.swing.GroupLayout mainPanelLayout = new javax.swing.GroupLayout(mainPanel);
@@ -226,7 +227,7 @@
                 .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                 .addGroup(mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
-                    .addComponent(castObceComboBox, 0, 340, Short.MAX_VALUE)
-                    .addComponent(obecComboBox, 0, 340, Short.MAX_VALUE)
-                    .addComponent(oblastComboBox, 0, 340, Short.MAX_VALUE)))
+                    .addComponent(suburbComboBox, 0, 341, Short.MAX_VALUE)
+                    .addComponent(vitociComboBox, 0, 341, Short.MAX_VALUE)
+                    .addComponent(oblastComboBox, 0, 341, Short.MAX_VALUE)))
         );
         mainPanelLayout.setVerticalGroup(
@@ -239,13 +240,13 @@
                 .addGroup(mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                     .addComponent(obecLabel)
-                    .addComponent(obecComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE))
+                    .addComponent(vitociComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE))
                 .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                 .addGroup(mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                     .addComponent(castObceLabel)
-                    .addComponent(castObceComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE))
+                    .addComponent(suburbComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE))
                 .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
         );
+
         getContentPane().add(mainPanel);
-
     }// </editor-fold>//GEN-END:initComponents
 
@@ -278,22 +279,28 @@
         if (oblast == null) return;
 
-        obecComboBox.setModel(new DefaultComboBoxModel(oblast.getViToCis().toArray()));
-        obecComboBox.setEnabled(obecComboBox.getModel().getSize() > 1);
-
-        obecComboBoxItemStateChanged(null);
+        vitociComboBox.setModel(new DefaultComboBoxModel(oblast.getViToCis().toArray()));
+        vitociComboBox.setEnabled(vitociComboBox.getModel().getSize() > 1);
+        vitociComboBoxItemStateChanged(null);
     }//GEN-LAST:event_oblastComboBoxItemStateChanged
 
-    private void obecComboBoxItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_obecComboBoxItemStateChanged
-
-        ViToCi obec = (ViToCi) obecComboBox.getSelectedItem();
+    private void vitociComboBoxItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_vitociComboBoxItemStateChanged
+
+        ViToCi obec = (ViToCi) vitociComboBox.getSelectedItem();
         if (obec == null) return;
 
-        castObceComboBox.setModel(new DefaultComboBoxModel(obec.getSuburbs().toArray()));
-        castObceComboBox.setEnabled(castObceComboBox.getModel().getSize() > 1);
-
-        castObceComboBoxItemStateChanged(null);
-    }//GEN-LAST:event_obecComboBoxItemStateChanged
-
-        private void castObceComboBoxItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_castObceComboBoxItemStateChanged
+        if (obec.getSuburbs().size() > 0) {
+            Object[] suburbs = new Object[obec.getSuburbs().size() + 1];
+            suburbs[0] = obec;
+            for (int i=0; i<obec.getSuburbs().size(); i++)
+                suburbs[i+1] = obec.getSuburbs().get(i);
+            suburbComboBox.setModel(new DefaultComboBoxModel(suburbs));
+        } else
+            suburbComboBox.setModel(new DefaultComboBoxModel());
+
+        suburbComboBox.setEnabled(suburbComboBox.getModel().getSize() > 1);
+        suburbComboBoxItemStateChanged(null);
+    }//GEN-LAST:event_vitociComboBoxItemStateChanged
+
+        private void suburbComboBoxItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_suburbComboBoxItemStateChanged
 
         /*if (castObceComboBox.getSelectedItem() != null)
@@ -306,27 +313,26 @@
             checkSetSelected((ElementWithStreets) oblastComboBox.getSelectedItem());*/
 
-        if (castObceComboBox.getSelectedItem() != null)
-            selectedElement = ((ElementWithStreets) castObceComboBox.getSelectedItem());
-
-        else if (obecComboBox.getSelectedItem() != null)
-            selectedElement = ((ElementWithStreets) obecComboBox.getSelectedItem());
+        if (suburbComboBox.getSelectedItem() != null)
+            selectedElement = ((ElementWithStreets) suburbComboBox.getSelectedItem());
+
+        else if (vitociComboBox.getSelectedItem() != null)
+            selectedElement = ((ElementWithStreets) vitociComboBox.getSelectedItem());
 
         else if (oblastComboBox.getSelectedItem() != null)
             selectedElement = ((ElementWithStreets) oblastComboBox.getSelectedItem());
         
-        }//GEN-LAST:event_castObceComboBoxItemStateChanged
+        }//GEN-LAST:event_suburbComboBoxItemStateChanged
 
     // Variables declaration - do not modify//GEN-BEGIN:variables
-    private javax.swing.JComboBox castObceComboBox;
     private javax.swing.JLabel castObceLabel;
     private javax.swing.JPanel mainPanel;
-    private javax.swing.JComboBox obecComboBox;
     private javax.swing.JLabel obecLabel;
     private javax.swing.JComboBox oblastComboBox;
     private javax.swing.JLabel oblastLabel;
+    private javax.swing.JComboBox suburbComboBox;
+    private javax.swing.JComboBox vitociComboBox;
     // End of variables declaration//GEN-END:variables
 
     private class AddressElementRenderer extends DefaultListCellRenderer {
-
         @Override
         public Component getListCellRendererComponent(
@@ -334,5 +340,6 @@
                     boolean isSelected, boolean cellHasFocus) {
 
-            Component c = super.getListCellRendererComponent(list, value, index, isSelected, cellHasFocus);
+            Component c = super.getListCellRendererComponent(list, value, index,
+                                                      isSelected, cellHasFocus);
 
             if (value instanceof AddressElement && !(value instanceof Region))
@@ -342,3 +349,20 @@
         }
     }
+
+    private class SuburbRenderer extends AddressElementRenderer {
+        @Override
+        public Component getListCellRendererComponent(JList list, Object value,
+                          int index, boolean isSelected, boolean cellHasFocus) {
+            Component c = super.getListCellRendererComponent(list, value,
+                                               index, isSelected, cellHasFocus);
+
+            if (value instanceof ViToCi) {
+                setFont(getFont().deriveFont(Font.BOLD));
+                setText(((ViToCi) value).getName() + ", všechny části obce");
+            } else
+                setFont(getFont().deriveFont(Font.PLAIN));
+
+            return c;
+        }
+    }
 }
Index: applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/gui/ManagerDialog.form
===================================================================
--- applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/gui/ManagerDialog.form	(revision 15582)
+++ applications/editors/josm/plugins/czechaddress/src/org/openstreetmap/josm/plugins/czechaddress/gui/ManagerDialog.form	(revision 15582)
@@ -0,0 +1,166 @@
+<?xml version="1.0" encoding="UTF-8" ?>
+
+<Form version="1.5" maxVersion="1.7" type="org.netbeans.modules.form.forminfo.JDialogFormInfo">
+  <Properties>
+    <Property name="defaultCloseOperation" type="int" value="2"/>
+  </Properties>
+  <SyntheticProperties>
+    <SyntheticProperty name="formSizePolicy" type="int" value="1"/>
+  </SyntheticProperties>
+  <AuxValues>
+    <AuxValue name="FormSettings_autoResourcing" type="java.lang.Integer" value="0"/>
+    <AuxValue name="FormSettings_autoSetComponentName" type="java.lang.Boolean" value="false"/>
+    <AuxValue name="FormSettings_generateFQN" type="java.lang.Boolean" value="true"/>
+    <AuxValue name="FormSettings_generateMnemonicsCode" type="java.lang.Boolean" value="false"/>
+    <AuxValue name="FormSettings_i18nAutoMode" type="java.lang.Boolean" value="false"/>
+    <AuxValue name="FormSettings_layoutCodeTarget" type="java.lang.Integer" value="1"/>
+    <AuxValue name="FormSettings_listenerGenerationStyle" type="java.lang.Integer" value="0"/>
+    <AuxValue name="FormSettings_variablesLocal" type="java.lang.Boolean" value="false"/>
+    <AuxValue name="FormSettings_variablesModifier" type="java.lang.Integer" value="2"/>
+    <AuxValue name="designerSize" type="java.awt.Dimension" value="-84,-19,0,5,115,114,0,18,106,97,118,97,46,97,119,116,46,68,105,109,101,110,115,105,111,110,65,-114,-39,-41,-84,95,68,20,2,0,2,73,0,6,104,101,105,103,104,116,73,0,5,119,105,100,116,104,120,112,0,0,1,-84,0,0,1,-74"/>
+  </AuxValues>
+
+  <Layout class="org.netbeans.modules.form.compat2.layouts.DesignGridLayout">
+    <Property name="columns" type="int" value="0"/>
+    <Property name="rows" type="int" value="1"/>
+  </Layout>
+  <SubComponents>
+    <Container class="javax.swing.JPanel" name="mainPanel">
+
+      <Layout class="org.netbeans.modules.form.compat2.layouts.DesignGridLayout">
+        <Property name="columns" type="int" value="0"/>
+        <Property name="rows" type="int" value="1"/>
+      </Layout>
+      <SubComponents>
+        <Container class="javax.swing.JTabbedPane" name="tabbedPane">
+
+          <Layout class="org.netbeans.modules.form.compat2.layouts.support.JTabbedPaneSupportLayout"/>
+          <SubComponents>
+            <Container class="javax.swing.JPanel" name="jPanel1">
+              <Constraints>
+                <Constraint layoutClass="org.netbeans.modules.form.compat2.layouts.support.JTabbedPaneSupportLayout" value="org.netbeans.modules.form.compat2.layouts.support.JTabbedPaneSupportLayout$JTabbedPaneConstraintsDescription">
+                  <JTabbedPaneConstraints tabName="N&#xe1;vrhy na p&#x159;ejmenov&#xe1;n&#xed;">
+                    <Property name="tabTitle" type="java.lang.String" value="N&#xe1;vrhy na p&#x159;ejmenov&#xe1;n&#xed;"/>
+                  </JTabbedPaneConstraints>
+                </Constraint>
+              </Constraints>
+
+              <Layout>
+                <DimensionLayout dim="0">
+                  <Group type="103" groupAlignment="0" attributes="0">
+                      <Group type="102" alignment="1" attributes="0">
+                          <EmptySpace pref="253" max="32767" attributes="0"/>
+                          <Component id="renamerButton" min="-2" max="-2" attributes="0"/>
+                          <EmptySpace max="-2" attributes="0"/>
+                      </Group>
+                      <Component id="streetScrollPane" alignment="0" pref="426" max="32767" attributes="0"/>
+                  </Group>
+                </DimensionLayout>
+                <DimensionLayout dim="1">
+                  <Group type="103" groupAlignment="0" attributes="0">
+                      <Group type="102" alignment="1" attributes="0">
+                          <Component id="streetScrollPane" pref="342" max="32767" attributes="0"/>
+                          <EmptySpace max="-2" attributes="0"/>
+                          <Component id="renamerButton" min="-2" max="-2" attributes="0"/>
+                          <EmptySpace max="-2" attributes="0"/>
+                      </Group>
+                  </Group>
+                </DimensionLayout>
+              </Layout>
+              <SubComponents>
+                <Container class="javax.swing.JScrollPane" name="streetScrollPane">
+                  <AuxValues>
+                    <AuxValue name="autoScrollPane" type="java.lang.Boolean" value="true"/>
+                  </AuxValues>
+
+                  <Layout class="org.netbeans.modules.form.compat2.layouts.support.JScrollPaneSupportLayout"/>
+                  <SubComponents>
+                    <Component class="javax.swing.JTable" name="renameTable">
+                      <Properties>
+                        <Property name="model" type="javax.swing.table.TableModel" editor="org.netbeans.modules.form.editors2.TableModelEditor">
+                          <Table columnCount="2" rowCount="4">
+                            <Column editable="false" title="P&#x16f;vodn&#xed; n&#xe1;zev" type="java.lang.Object"/>
+                            <Column editable="true" title="N&#xe1;vrh z mapy" type="java.lang.String"/>
+                          </Table>
+                        </Property>
+                        <Property name="columnSelectionAllowed" type="boolean" value="true"/>
+                        <Property name="tableHeader" type="javax.swing.table.JTableHeader" editor="org.netbeans.modules.form.editors2.JTableHeaderEditor">
+                          <TableHeader reorderingAllowed="true" resizingAllowed="true"/>
+                        </Property>
+                      </Properties>
+                    </Component>
+                  </SubComponents>
+                </Container>
+                <Component class="javax.swing.JButton" name="renamerButton">
+                  <Properties>
+                    <Property name="text" type="java.lang.String" value="Pou&#x17e;&#xed;t navr&#x17e;en&#xe9; zm&#x11b;ny"/>
+                  </Properties>
+                  <Events>
+                    <EventHandler event="actionPerformed" listener="java.awt.event.ActionListener" parameters="java.awt.event.ActionEvent" handler="renamerButtonActionPerformed"/>
+                  </Events>
+                </Component>
+              </SubComponents>
+            </Container>
+            <Container class="javax.swing.JPanel" name="jPanel2">
+              <Constraints>
+                <Constraint layoutClass="org.netbeans.modules.form.compat2.layouts.support.JTabbedPaneSupportLayout" value="org.netbeans.modules.form.compat2.layouts.support.JTabbedPaneSupportLayout$JTabbedPaneConstraintsDescription">
+                  <JTabbedPaneConstraints tabName="Inspektor datab&#xe1;ze">
+                    <Property name="tabTitle" type="java.lang.String" value="Inspektor datab&#xe1;ze"/>
+                  </JTabbedPaneConstraints>
+                </Constraint>
+              </Constraints>
+
+              <Layout>
+                <DimensionLayout dim="0">
+                  <Group type="103" groupAlignment="0" attributes="0">
+                      <Component id="jScrollPane1" alignment="0" pref="426" max="32767" attributes="0"/>
+                      <Group type="102" alignment="1" attributes="0">
+                          <EmptySpace pref="356" max="32767" attributes="0"/>
+                          <Component id="dbEditButton" min="-2" max="-2" attributes="0"/>
+                          <EmptySpace max="-2" attributes="0"/>
+                      </Group>
+                  </Group>
+                </DimensionLayout>
+                <DimensionLayout dim="1">
+                  <Group type="103" groupAlignment="0" attributes="0">
+                      <Group type="102" alignment="1" attributes="0">
+                          <Component id="jScrollPane1" pref="342" max="32767" attributes="0"/>
+                          <EmptySpace max="-2" attributes="0"/>
+                          <Component id="dbEditButton" min="-2" max="-2" attributes="0"/>
+                          <EmptySpace max="-2" attributes="0"/>
+                      </Group>
+                  </Group>
+                </DimensionLayout>
+              </Layout>
+              <SubComponents>
+                <Container class="javax.swing.JScrollPane" name="jScrollPane1">
+                  <AuxValues>
+                    <AuxValue name="autoScrollPane" type="java.lang.Boolean" value="true"/>
+                  </AuxValues>
+
+                  <Layout class="org.netbeans.modules.form.compat2.layouts.support.JScrollPaneSupportLayout"/>
+                  <SubComponents>
+                    <Component class="javax.swing.JTree" name="dbTree">
+                      <Events>
+                        <EventHandler event="valueChanged" listener="javax.swing.event.TreeSelectionListener" parameters="javax.swing.event.TreeSelectionEvent" handler="dbTreeValueChanged"/>
+                      </Events>
+                    </Component>
+                  </SubComponents>
+                </Container>
+                <Component class="javax.swing.JButton" name="dbEditButton">
+                  <Properties>
+                    <Property name="text" type="java.lang.String" value="Upravit"/>
+                    <Property name="enabled" type="boolean" value="false"/>
+                  </Properties>
+                  <Events>
+                    <EventHandler event="actionPerformed" listener="java.awt.event.ActionListener" parameters="java.awt.event.ActionEvent" handler="dbEditButtonActionPerformed"/>
+                  </Events>
+                </Component>
+              </SubComponents>
+            </Container>
+          </SubComponents>
+        </Container>
+      </SubComponents>
+    </Container>
+  </SubComponents>
+</Form>
